<mat-card class="attendance-card">
  <app-loader *ngIf="isLoading"></app-loader>
  <mat-card-header>
    <mat-card-title>Mark Attendance For Today</mat-card-title>
  </mat-card-header>
  <mat-card-content>
    <form class="example-form" [formGroup]="attendanceForm" (ngSubmit)="onSubmit()">
      <mat-checkbox [formControl]="attendanceForm.controls['noclass']" (change)="onNoClassChange()">No class today !</mat-checkbox>

      <mat-form-field class="example-full-width">
        <input type="text" [errorStateMatcher]="errorMatcher" [formControl]="attendanceForm.controls['noclassreason']" placeholder="Reason for no class" matInput maxlength="20">
        <mat-error *ngIf="attendanceForm.hasError('noreasonmissing')">
          Enter reason for no class.
        </mat-error>
      </mat-form-field>

      <mat-form-field class="example-full-width">
        <mat-label>Select a student</mat-label>
        <mat-select [errorStateMatcher]="errorMatcher" [formControl]="attendanceForm.controls['user']">
          <mat-option *ngFor="let option of filteredUsers | async" [value]="option">
            {{option.name}}
          </mat-option>
        </mat-select>
        <mat-error *ngIf="attendanceForm.hasError('usermissing')">
          Please select a student
        </mat-error>
      </mat-form-field>

      <mat-form-field class="example-full-width">
        <mat-label>Select coaching type</mat-label>
        <mat-select [errorStateMatcher]="errorMatcher" [formControl]="attendanceForm.controls['coachingtype']">
          <mat-option *ngFor="let option of coachingTypes" [value]="option">
            {{option.value}}
          </mat-option>
        </mat-select>
        <mat-error *ngIf="attendanceForm.hasError('cochingtypemissing')">
          Please select coaching type
        </mat-error>
      </mat-form-field>

      <mat-checkbox [formControl]="attendanceForm.controls['isabsent']" (change)="onIsAbsentChange()">Student is Absent?</mat-checkbox>
      <mat-form-field class="example-full-width">
        <input type="text" placeholder="Start time in HH:MM (24hr format)" aria-label="Number" matInput [errorStateMatcher]="errorMatcher" [formControl]="attendanceForm.controls['startdate']">
        <mat-error *ngIf="attendanceForm.hasError('startdatemissing')">
          Please enter starttime
        </mat-error>
        <mat-error *ngIf="attendanceForm.hasError('startdateinvalid')">
          Please enter start time in HH:MM 24 hr format
        </mat-error>
        <mat-error *ngIf="attendanceForm.hasError('stardategreatethanenddate')">
          Start time must be less than end time
        </mat-error>
        <mat-error *ngIf="attendanceForm.hasError('stardatesameasenddate')">
          Start time cannot be same as end time
        </mat-error>
      </mat-form-field>

      <mat-form-field class="example-full-width">
        <input type="text" placeholder="End time in HH:MM (24hr format)" aria-label="Number" matInput [errorStateMatcher]="errorMatcher" [formControl]="attendanceForm.controls['enddate']">
        <mat-error *ngIf="attendanceForm.hasError('enddatemissing')">
          Please enter endtime
        </mat-error>
        <mat-error *ngIf="attendanceForm.hasError('enddateinvalid')">
          Please enter end time in HH:MM 24 hr format
        </mat-error>
        <mat-error *ngIf="attendanceForm.hasError('stardategreatethanenddate')">
          Start time must be less than end time
        </mat-error>
        <mat-error *ngIf="attendanceForm.hasError('stardatesameasenddate')">
          Start time cannot be same as end time
        </mat-error>
      </mat-form-field>

      <mat-card-actions>
        <button  mat-raised-button color="primary" type="submit" [disabled]="attendanceForm.invalid">Save Attendance</button>
      </mat-card-actions>
    </form>
  </mat-card-content>
</mat-card>
